#pragma once

#include "4DPluginAPI.h"
#include "Magick++.h"
using namespace Magick; 

#if WIN32
	#define strlcat(a, b, c) strcat_s(a, c, b)
	#define strlcpy(a, b, c) strcpy_s(a, c, b)
#else
#ifndef min
#define min(a,b) (((a) < (b)) ? (a) : (b))
#endif
#ifndef max
#define max(a,b) (((a) > (b)) ? (a) : (b))
#endif
#endif

#define ImageMagickErrorUnknownObject  -1
#define ImageMagickErrorFramework  -2
#define ImageMagickErrorUnitialized  -3
#define ImageMagickErrorUnknownCommand  -4

class IMImage
{
	Image image;
	char LastError[255];
	short Initialized;
public:
	IMImage(void);
	~IMImage(void);
	int read(char * path);
	int read(void * data, const int length);
	int create(int x, int y, char * color);
	int write(char * path);
	int write(PA_Handle data);
	int GetProperty(long Selector, char * string, double &para1, double &para2, double &para3, double &para4);
	int SetProperty(long Selector, char * stringpara, double para1, double para2, double para3, double para4);
	int ModifyImage(long Selector, char * stringpara, double para1, double para2, double para3, double para4, double para5, double para6);
	int Draw(long Selector, char * stringpara, double para1, double para2, double para3, double para4, double para5, double para6);
	char * GetLastError(void);
};
